<!--
.. title: Adding Google Analytics To All Pages Using Flask
.. slug: adding-google-analytics-to-all-pages
.. date: 2016-09-29T18:02:00+05:30
.. tags: Flask,google analytics
.. link: 
.. description:
.. type: text
-->

<div dir="ltr" style="text-align: left;" trbidi="on"><div style="color: #333333; font-family: &quot;Noto Serif&quot;, serif; font-size: 17px; margin-bottom: 28px;">Google Analytics gives a detailed insight about your website including how many people visited, time, demography, how many returning visitors and all such information. It's a real important tool to have.&nbsp;All you have to do is create a Universal Analytics Tracking code and use it in a javascript code. The only problem is this code needs to be present in all the pages that you wants the analytics data for. So changing any part of the javascript code anytime, needs to be changed in all .html files.</div><div style="color: #333333; font-family: &quot;Noto Serif&quot;, serif; font-size: 17px; margin-bottom: 28px;">However, there is a better way of doing it in flask. Create a file base.html and write the code:</div><blockquote style="border-left: 4px solid rgb(112, 112, 112); color: #707070; font-family: &quot;Noto Serif&quot;, serif; font-size: 20px; font-style: italic; line-height: 1.8182; margin: 0px 0px 35px -21px; padding-left: 17px;"><div style="margin-bottom: 35px;">&lt;script&gt;<br />(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){<br />(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),<br />m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)<br />})(window,document,'script','https://www.google-analytics.com/analytics.js','ga');</div><div style="margin-bottom: 35px;">ga('create', '&lt;track-code&gt;', 'auto');<br />ga('send', 'pageview');</div>&lt;/script&gt;</blockquote><div style="color: #333333; font-family: &quot;Noto Serif&quot;, serif; font-size: 17px; margin-bottom: 28px;">Then using the property of jinja2 template extend this file in all the html files, i.e.&nbsp;{% extends 'gentelella/admin/base.html' %}. Thus now when you make some change in the above mentioned javascrpt code, you need to change it only in one place and it is changed in all other places.</div></div>